const char *default_config =
"servers = (\n"
"  { address = \"irc.stealth.net\"; chatnet = IRCNet; port = 6668; },\n"
"  { address = \"irc.efnet.net\"; chatnet = EFNet; port = 6667; },\n"
"  { address = \"irc.undernet.org\"; chatnet = Undernet; port = 6667; },\n"
"  { address = \"irc.dal.net\"; chatnet = DALnet; port = 6667; },\n"
"  { address = \"irc.openprojects.net\"; chatnet = OPN; port = 6667; },\n"
"  { address = \"irc.ptlink.net\"; chatnet = PTlink; port = 6667; },\n"
"  { address = \"silc.pspt.fi\"; chatnet = SILC; port = 706; }\n"
");\n"
"\n"
"chatnets = {\n"
"  IRCNet = { type = \"IRC\"; max_kicks = 4; max_modes = 3; max_msgs = 5; max_whois = 4; max_query_chans = \"5\"; };\n"
"  EFNet = { type = \"IRC\"; max_kicks = 4; max_modes = 4; max_msgs = 3; };\n"
"  Undernet = { type = \"IRC\"; max_kicks = 4; max_modes = 3; max_msgs = 3; };\n"
"  DALNet = { type = \"IRC\"; max_kicks = 4; max_modes = 6; max_msgs = 3; };\n"
"  OPN = { type = \"IRC\"; max_kicks = 1; max_modes = 4; max_msgs = 100; };\n"
"  PTLink = { type = \"IRC\"; max_kicks = 1; max_modes = 6; max_msgs = 100; };\n"
"  SILC = { type = \"SILC\"; };\n"
"};\n"
"\n"
"channels = (\n"
"  { name = \"#irssi\"; chatnet = ircnet; autojoin = No; },\n"
"  { name = \"#irssi\"; chatnet = opn; autojoin = No; },\n"
"  { name = \"#silc\"; chatnet = silc; autojoin = No; }\n"
");\n"
"\n"
"aliases = {\n"
"  J = \"join\";\n"
"  WJOIN = \"join -window\";\n"
"  WQUERY = \"query -window\";\n"
"  LEAVE = \"part\";\n"
"  BYE = \"quit\";\n"
"  EXIT = \"quit\";\n"
"  SIGNOFF = \"quit\";\n"
"  DESCRIBE = \"action\";\n"
"  DATE = \"time\";\n"
"  HOST = \"userhost\";\n"
"  LAST = \"lastlog\";\n"
"  SAY = \"msg *\";\n"
"  WI = \"whois\";\n"
"  WII = \"whois $0 $0\";\n"
"  WW = \"whowas\";\n"
"  W = \"who\";\n"
"  N = \"names\";\n"
"  M = \"msg\";\n"
"  T = \"topic\";\n"
"  C = \"clear\";\n"
"  CL = \"clear\";\n"
"  K = \"kick\";\n"
"  KB = \"kickban\";\n"
"  KN = \"knockout\";\n"
"  BANS = \"ban\";\n"
"  B = \"ban\";\n"
"  MUB = \"unban *\";\n"
"  UB = \"unban\";\n"
"  IG = \"ignore\";\n"
"  UNIG = \"unignore\";\n"
"  SB = \"scrollback\";\n"
"  UMODE = \"mode $N\";\n"
"  WC = \"window close\";\n"
"  WN = \"window new hide\";\n"
"  SV = \"say Irssi $J ($V) - http://irssi.org/\";\n"
"  GOTO = \"sb goto\";\n"
"  CHAT = \"dcc chat\";\n"
"  RUN = \"SCRIPT LOAD\";\n"
"  UPTIME = \"eval exec - expr `date +%s` - \\\\$F | awk '{print \\\"Irssi uptime: \\\"int(\\\\\\\\\\\\$1/3600/24)\\\"d \\\"int(\\\\\\\\\\\\$1/3600%24)\\\"h \\\"int(\\\\\\\\\\\\$1/60%60)\\\"m \\\"int(\\\\\\\\\\\\$1%60)\\\"s\\\" }'\";\n"
"  CALC = \"exec - if which bc &>/dev/null\\\\; then echo '$*' | bc | awk '{print \\\"$*=\\\"$$1}'\\\\; else echo bc was not found\\\\; fi\";\n"
"};\n"
"\n"
"statusbar = {\n"
"  # formats:\n"
"  # when using {templates}, the template is shown only if it's argument isn't\n"
"  # empty unless no argument is given. for example {sb} is printed always,\n"
"  # but {sb $T} is printed only if $T isn't empty.\n"
"\n"
"  items = {\n"
"    # start/end text in statusbars\n"
"    barstart = \"{sbstart}\";\n"
"    barend = \"{sbend}\";\n"
"\n"
"    # treated \"normally\", you could change the time/user name to whatever\n"
"    time = \"{sb $Z}\";\n"
"    user = \"{sb $cumode$N{sbmode $usermode}{sbaway $A}}\";\n"
"    topic = \" $topic\";\n"
"    info = \" Irssi v$J - http://irssi.org/beginner/ - read it to get rid of this\";\n"
"\n"
"    # treated specially .. window is printed with non-empty windows,\n"
"    # window_empty is printed with empty windows\n"
"    window = \"{sb $winref:$T{sbmode $M}}\";\n"
"    window_empty = \"{sb $winref{sbservertag $tag}}\";\n"
"    prompt = \"{prompt $[.15]T}\";\n"
"    prompt_empty = \"{prompt $winname}\";\n"
"\n"
"    # all of these treated specially, they're only displayed when needed\n"
"    lag = \"{sb Lag: $0-}\";\n"
"    act = \"{sb Act: $0-}\";\n"
"    more = \"-- more --\";\n"
"  };\n"
"\n"
"  # there's two type of statusbars. root statusbars are either at the top\n"
"  # of the screen or at the bottom of the screen. window statusbars are at\n"
"  # the top/bottom of each split window in screen.\n"
"  default = {\n"
"    # the \"default statusbar\" to be displayed at the bottom of the window.\n"
"    # contains all the normal items.\n"
"    window = {\n"
"      # window, root\n"
"      type = \"window\";\n"
"      # top, bottom\n"
"      placement = \"bottom\";\n"
"      # number\n"
"      position = \"1\";\n"
"      # active, inactive, always, never (disables the statusbar)\n"
"      visible = \"active\";\n"
"\n"
"      # list of items in statusbar in the display order\n"
"      items = {\n"
"        barstart = { priority = \"100\"; };\n"
"        time = { };\n"
"        user = { };\n"
"        window = { };\n"
"        window_empty = { };\n"
"        lag = { priority = \"-1\"; };\n"
"        act = { priority = \"10\"; };\n"
"        more = { priority = \"-1\"; alignment = \"right\"; };\n"
"        barend = { priority = \"100\"; alignment = \"right\"; };\n"
"      };\n"
"    };\n"
"\n"
"    # statusbar to use in inactive split windows\n"
"    window_inact = {\n"
"      type = \"window\";\n"
"      placement = \"bottom\";\n"
"      position = \"1\";\n"
"      visible = \"inactive\";\n"
"      items = {\n"
"        barstart = { priority = \"100\"; };\n"
"        window = { };\n"
"	window_empty = { };\n"
"        more = { priority = \"-1\"; alignment = \"right\"; };\n"
"        barend = { priority = \"100\"; alignment = \"right\"; };\n"
"      };\n"
"    };\n"
"\n"
"    # (annoying) infobar requesting new users to visit irssi.org and read\n"
"    # a bit of documentation :)\n"
"    info = {\n"
"      type = \"root\";\n"
"      placement = \"bottom\";\n"
"      position = \"1\";\n"
"      visible = \"always\";\n"
"      items = { info = { }; };\n"
"    };\n"
"\n"
"    # we treat input line as yet another statusbar :) It's possible to\n"
"    # add other items before or after the input line item.\n"
"    prompt = {\n"
"      type = \"root\";\n"
"      placement = \"bottom\";\n"
"      # we want to be at the bottom always\n"
"      position = \"100\";\n"
"      visible = \"always\";\n"
"      items = {\n"
"        prompt = { priority = \"-1\"; };\n"
"        prompt_empty = { priority = \"-1\"; };\n"
"        # treated specially, this is the real input line.\n"
"        input = { priority = \"10\"; };\n"
"      };\n"
"    };\n"
"\n"
"    # topicbar\n"
"    topic = {\n"
"      type = \"root\";\n"
"      placement = \"top\";\n"
"      position = \"1\";\n"
"      visible = \"always\";\n"
"      items = {\n"
"        barstart = { priority = \"100\"; };\n"
"        topic = { };\n"
"        barend = { priority = \"100\"; alignment = \"right\"; };\n"
"      };\n"
"    };\n"
"  };\n"
"};\n"
;
