
/* : : generated by proto : : */
#ifndef __CHAT_PROTOCOLS_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __CHAT_PROTOCOLS_H

typedef struct {
	int id;

	unsigned int not_initialized:1;
	unsigned int case_insensitive:1;

	char *name;
	char *fullname;
	char *chatnet;

        CHATNET_REC *(*create_chatnet)  __PROTO__((void));
	SERVER_SETUP_REC *(*create_server_setup)  __PROTO__((void));
        CHANNEL_SETUP_REC *(*create_channel_setup)  __PROTO__((void));
	SERVER_CONNECT_REC *(*create_server_connect)  __PROTO__((void));
        void (*destroy_server_connect)  __PROTO__((SERVER_CONNECT_REC *));

        SERVER_REC *(*server_connect)  __PROTO__((SERVER_CONNECT_REC *));
        CHANNEL_REC *(*channel_create)  __PROTO__((SERVER_REC *, const char *, int));
        QUERY_REC *(*query_create)  __PROTO__((const char *, const char *, int));
} CHAT_PROTOCOL_REC;

extern __MANGLE__ GSList *chat_protocols;

#define PROTO_CHECK_CAST(object, cast, type_field, id) \
	((cast *) chat_protocol_check_cast(object, \
				offsetof(cast, type_field), id))
__V_ *chat_protocol_check_cast __PROTO__((__V_ *object, int type_pos, const char *id));

#define CHAT_PROTOCOL(object) \
	((object) == NULL ? chat_protocol_get_default() : \
	chat_protocol_find_id((object)->chat_type))

/* Register new chat protocol. */
CHAT_PROTOCOL_REC *chat_protocol_register __PROTO__((CHAT_PROTOCOL_REC *rec));

/* Unregister chat protocol. */
void chat_protocol_unregister __PROTO__((const char *name));

/* Find functions */
int chat_protocol_lookup __PROTO__((const char *name));
CHAT_PROTOCOL_REC *chat_protocol_find __PROTO__((const char *name));
CHAT_PROTOCOL_REC *chat_protocol_find_id __PROTO__((int id));
CHAT_PROTOCOL_REC *chat_protocol_find_net __PROTO__((GHashTable *optlist));

/* Default chat protocol to use */
void chat_protocol_set_default __PROTO__((CHAT_PROTOCOL_REC *rec));
CHAT_PROTOCOL_REC *chat_protocol_get_default __PROTO__((void));

/* Return "unknown chat protocol" record. Used when protocol name is
   specified but it isn't registered yet. */
CHAT_PROTOCOL_REC *chat_protocol_get_unknown __PROTO__((const char *name));

void chat_protocols_init __PROTO__((void));
void chat_protocols_deinit __PROTO__((void));

#endif
