
/* : : generated by proto : : */
#ifndef __EXPANDOS_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __EXPANDOS_H

#include "signals.h"

/* first argument of signal must match to active .. */
typedef enum {
        EXPANDO_ARG_NONE = 1,
        EXPANDO_ARG_SERVER,
        EXPANDO_ARG_WINDOW,
	EXPANDO_ARG_WINDOW_ITEM,

	EXPANDO_NEVER /* special: expando never changes */
} ExpandoArg;

typedef char* (*EXPANDO_FUNC)
	 __PROTO__((SERVER_REC *server, __V_ *item, int *free_ret));

/* Create expando - overrides any existing ones.
   ... = signal, type, ..., NULL - list of signals that might change the
   value of this expando */
void expando_create __PROTO__((const char *key, EXPANDO_FUNC func, ...));
/* Add new signal to expando */
void expando_add_signal __PROTO__((const char *key, const char *signal, ExpandoArg arg));
/* Destroy expando */
void expando_destroy __PROTO__((const char *key, EXPANDO_FUNC func));

void expando_bind __PROTO__((const char *key, int funccount, SIGNAL_FUNC *funcs));
void expando_unbind __PROTO__((const char *key, int funccount, SIGNAL_FUNC *funcs));

/* Returns [<signal id>, EXPANDO_ARG_xxx, <signal id>, ..., -1] */
int *expando_get_signals __PROTO__((const char *key));

/* internal: */
EXPANDO_FUNC expando_find_char __PROTO__((char chr));
EXPANDO_FUNC expando_find_long __PROTO__((const char *key));

void expandos_init __PROTO__((void));
void expandos_deinit __PROTO__((void));

#endif
