
/* : : generated by proto : : */
#ifndef __NET_NONBLOCK_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __NET_NONBLOCK_H

#include "network.h"

typedef struct {
	IPADDR ip4, ip6; /* resolved ip addresses */
	int error; /* error, 0 = no error, -1 = error: */
	int errlen; /* error text length */
	char *errorstr; /* error string - dynamically allocated, you'll
	                   need to free() it yourself unless it's NULL */
} RESOLVED_IP_REC;

typedef struct {
        int namelen;
	char *name;

	int error;
	int errlen;
	char *errorstr;
} RESOLVED_NAME_REC;

typedef void (*NET_CALLBACK)  __PROTO__((GIOChannel *, __V_ *));
typedef void (*NET_HOST_CALLBACK)  __PROTO__((RESOLVED_NAME_REC *, __V_ *));

/* nonblocking gethostbyname(), PID of the resolver child is returned. */
int net_gethostbyname_nonblock __PROTO__((const char *addr, GIOChannel *pipe));
/* Get host's name, call func when finished */
int net_gethostbyaddr_nonblock __PROTO__((IPADDR *ip, NET_HOST_CALLBACK func, __V_ *data));
/* get the resolved IP address. returns -1 if some error occured with read() */
int net_gethostbyname_return __PROTO__((GIOChannel *pipe, RESOLVED_IP_REC *rec));

/* Connect to server, call func when finished */
int net_connect_nonblock __PROTO__((const char *server, int port, const IPADDR *my_ip,
			 NET_CALLBACK func, __V_ *data));
/* Kill the resolver child */
void net_disconnect_nonblock __PROTO__((int pid));

#endif
