
/* : : generated by proto : : */
#ifndef __NETWORK_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __NETWORK_H

#ifdef HAVE_SOCKS_H
#include <socks.h>
#endif

#include <sys/types.h>
#ifndef WIN32
#  include <sys/socket.h>
#  include <netinet/in.h>
#  include <netdb.h>
#  include <arpa/inet.h>
#endif

#ifndef AF_INET6
#  ifdef PF_INET6
#    define AF_INET6 PF_INET6
#  else
#    define AF_INET6 10
#  endif
#endif

struct _IPADDR {
	unsigned short family;
#ifdef HAVE_IPV6
	struct in6_addr ip;
#else
	struct in_addr ip;
#endif
};

/* maxmimum string length of IP address */
#ifdef HAVE_IPV6
#  define MAX_IP_LEN INET6_ADDRSTRLEN
#else
#  define MAX_IP_LEN 20
#endif

#define IPADDR_IS_V6(ip) ((ip)->family != AF_INET)

/* returns 1 if IPADDRs are the same */
int net_ip_compare __PROTO__((IPADDR *ip1, IPADDR *ip2));

/* Connect to socket */
GIOChannel *net_connect __PROTO__((const char *addr, int port, IPADDR *my_ip));
/* Connect to socket with ip address */
GIOChannel *net_connect_ip __PROTO__((IPADDR *ip, int port, IPADDR *my_ip));
/* Disconnect socket */
void net_disconnect __PROTO__((GIOChannel *handle));
/* Try to let the other side close the connection, if it still isn't
   disconnected after certain amount of time, close it ourself */
void net_disconnect_later __PROTO__((GIOChannel *handle));

/* Listen for connections on a socket */
GIOChannel *net_listen __PROTO__((IPADDR *my_ip, int *port));
/* Accept a connection on a socket */
GIOChannel *net_accept __PROTO__((GIOChannel *handle, IPADDR *addr, int *port));

/* Read data from socket, return number of bytes read, -1 = error */
int net_receive __PROTO__((GIOChannel *handle, char *buf, int len));
/* Transmit data, return number of bytes sent, -1 = error */
int net_transmit __PROTO__((GIOChannel *handle, const char *data, int len));

/* Get IP addresses for host, both IPv4 and IPv6 if possible.
   If ip->family is 0, the address wasn't found.
   Returns 0 = ok, others = error code for net_gethosterror() */
int net_gethostbyname __PROTO__((const char *addr, IPADDR *ip4, IPADDR *ip6));
/* Get name for host, *name should be g_free()'d unless it's NULL.
   Return values are the same as with net_gethostbyname() */
int net_gethostbyaddr __PROTO__((IPADDR *ip, char **name));
/* get error of net_gethostname() */
const char *net_gethosterror __PROTO__((int error));
/* return TRUE if host lookup failed because it didn't exist (ie. not
   some error with name server) */
int net_hosterror_notfound __PROTO__((int error));

/* Get socket address/port */
int net_getsockname __PROTO__((GIOChannel *handle, IPADDR *addr, int *port));

/* IPADDR -> char* translation. `host' must be at least MAX_IP_LEN bytes */
int net_ip2host __PROTO__((IPADDR *ip, char *host));
/* char* -> IPADDR translation. */
int net_host2ip __PROTO__((const char *host, IPADDR *ip));

/* Get socket error */
int net_geterror __PROTO__((GIOChannel *handle));

/* Get name of TCP service */
char *net_getservbyport __PROTO__((int port));

int is_ipv4_address __PROTO__((const char *host));
int is_ipv6_address __PROTO__((const char *host));

#endif
