
/* : : generated by proto : : */
#ifndef __NICKLIST_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __NICKLIST_H

/* Returns NICK_REC if it's nick, NULL if it isn't. */
#define NICK(server) \
	MODULE_CHECK_CAST(server, NICK_REC, type, "NICK")

#define IS_NICK(server) \
	(NICK(server) ? TRUE : FALSE)

struct _NICK_REC {
#include "nick-rec.h"
};

/* Add new nick to list */
void nicklist_insert __PROTO__((CHANNEL_REC *channel, NICK_REC *nick));
/* Set host address for nick */
void nicklist_set_host __PROTO__((CHANNEL_REC *channel, NICK_REC *nick, const char *host));
/* Remove nick from list */
void nicklist_remove __PROTO__((CHANNEL_REC *channel, NICK_REC *nick));
/* Change nick */
void nicklist_rename __PROTO__((SERVER_REC *server, const char *old_nick,
		     const char *new_nick));
void nicklist_rename_unique __PROTO__((SERVER_REC *server,
			    __V_ *old_nick_id, const char *old_nick,
			    __V_ *new_nick_id, const char *new_nick));

/* Find nick */
NICK_REC *nicklist_find __PROTO__((CHANNEL_REC *channel, const char *nick));
NICK_REC *nicklist_find_unique __PROTO__((CHANNEL_REC *channel, const char *nick,
			       __V_ *id));
/* Find nick mask, wildcards allowed */
NICK_REC *nicklist_find_mask __PROTO__((CHANNEL_REC *channel, const char *mask));
/* Get list of nicks that match the mask */
GSList *nicklist_find_multiple __PROTO__((CHANNEL_REC *channel, const char *mask));
/* Get list of nicks */
GSList *nicklist_getnicks __PROTO__((CHANNEL_REC *channel));
/* Get all the nick records of `nick'. Returns channel, nick, channel, ... */
GSList *nicklist_get_same __PROTO__((SERVER_REC *server, const char *nick));
GSList *nicklist_get_same_unique __PROTO__((SERVER_REC *server, __V_ *id));

/* Update specified nick's status in server. */
void nicklist_update_flags __PROTO__((SERVER_REC *server, const char *nick,
			   int gone, int ircop));
void nicklist_update_flags_unique __PROTO__((SERVER_REC *server, __V_ *id,
			   int gone, int ircop));

/* Specify which nick in channel is ours */
void nicklist_set_own __PROTO__((CHANNEL_REC *channel, NICK_REC *nick));

/* Nick record comparision for sort functions */
int nicklist_compare __PROTO__((NICK_REC *p1, NICK_REC *p2));

/* Check is `msg' is meant for `nick'. */
int nick_match_msg __PROTO__((CHANNEL_REC *channel, const char *msg, const char *nick));

void nicklist_init __PROTO__((void));
void nicklist_deinit __PROTO__((void));

#endif
