
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "signals.h"
#include "modules.h"

#include <sys/wait.h>

static GSList *pids;

static unsigned int childcheck_tag;
static int signal_pidwait;

/* add a pid to wait list */
void pidwait_add __PARAM__((int pid), (pid)) __OTORP__(int pid;){
	pids = g_slist_append(pids, GINT_TO_POINTER(pid));
}

/* remove pid from wait list */
void pidwait_remove __PARAM__((int pid), (pid)) __OTORP__(int pid;){
	pids = g_slist_remove(pids, GINT_TO_POINTER(pid));
}

/* return list of pids that are being waited.
   don't free the return value. */
GSList *pidwait_get_pids __PARAM__((void), ()){
        return pids;
}

static int child_check __PARAM__((void), ()){
	GSList *tmp, *next;
	int status;

	/* wait for each pid.. */
	for (tmp = pids; tmp != NULL; tmp = next) {
		int pid = GPOINTER_TO_INT(tmp->data);

		next = tmp->next;
		if (waitpid(pid, &status, WNOHANG) > 0) {
			/* process terminated, remove from list */
			signal_emit_id(signal_pidwait, 2, tmp->data,
				       GINT_TO_POINTER(status));
			pids = g_slist_remove(pids, tmp->data);
		}
	}
	return 1;
}

void pidwait_init __PARAM__((void), ()){
	pids = NULL;
	childcheck_tag = g_timeout_add(1000, (GSourceFunc) child_check, NULL);

	signal_pidwait = signal_get_uniq_id("pidwait");
}

void pidwait_deinit __PARAM__((void), ()){
	g_slist_free(pids);

	g_source_remove(childcheck_tag);
}
