
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "signals.h"
#include "misc.h"

#include "servers.h"
#include "queries.h"

GSList *queries;

void query_init __PARAM__((QUERY_REC *query, int automatic), (query, automatic)) __OTORP__(QUERY_REC *query; int automatic;){
	g_return_if_fail(query != NULL);
	g_return_if_fail(query->name != NULL);

	queries = g_slist_append(queries, query);

        MODULE_DATA_INIT(query);
	query->type = module_get_uniq_id_str("WINDOW ITEM TYPE", "QUERY");
        query->destroy = query_destroy;
	if (query->server_tag != NULL) {
		query->server = server_find_tag(query->server_tag);
		if (query->server != NULL) {
			query->server->queries =
				g_slist_append(query->server->queries, query);
		}
	}

	signal_emit("query created", 2, query, GINT_TO_POINTER(automatic));
}

void query_destroy __PARAM__((QUERY_REC *query), (query)) __OTORP__(QUERY_REC *query;){
	g_return_if_fail(IS_QUERY(query));

        if (query->destroying) return;
	query->destroying = TRUE;

	queries = g_slist_remove(queries, query);
	if (query->server != NULL) {
		query->server->queries =
			g_slist_remove(query->server->queries, query);
	}
	signal_emit("query destroyed", 1, query);

        MODULE_DATA_DEINIT(query);
	g_free_not_null(query->hilight_color);
        g_free_not_null(query->server_tag);
        g_free_not_null(query->address);
	g_free(query->name);
	g_free(query);
}

static QUERY_REC *query_find_server __PARAM__((SERVER_REC *server, const char *nick), (server, nick)) __OTORP__(SERVER_REC *server; const char *nick;){
	GSList *tmp;

	g_return_val_if_fail(IS_SERVER(server), NULL);

	if (server->query_find_func != NULL) {
		/* use the server specific query find function */
		return server->query_find_func(server, nick);
	}

	for (tmp = server->queries; tmp != NULL; tmp = tmp->next) {
		QUERY_REC *rec = tmp->data;

		if (g_strcasecmp(rec->name, nick) == 0)
			return rec;
	}

	return NULL;
}

QUERY_REC *query_find __PARAM__((SERVER_REC *server, const char *nick), (server, nick)) __OTORP__(SERVER_REC *server; const char *nick;){
	GSList *tmp;

	g_return_val_if_fail(server == NULL || IS_SERVER(server), NULL);
	g_return_val_if_fail(nick != NULL, NULL);

	if (server != NULL)
		return query_find_server(server, nick);

	for (tmp = queries; tmp != NULL; tmp = tmp->next) {
		QUERY_REC *rec = tmp->data;

		if (g_strcasecmp(rec->name, nick) == 0)
			return rec;
	}

        return NULL;
}

void query_change_nick __PARAM__((QUERY_REC *query, const char *nick), (query, nick)) __OTORP__(QUERY_REC *query; const char *nick;){
	char *oldnick;

	g_return_if_fail(IS_QUERY(query));

        oldnick = query->name;
	query->name = g_strdup(nick);
	signal_emit("query nick changed", 2, query, oldnick);
        g_free(oldnick);
}

void query_change_address __PARAM__((QUERY_REC *query, const char *address), (query, address)) __OTORP__(QUERY_REC *query; const char *address;){
	g_return_if_fail(IS_QUERY(query));

        g_free_not_null(query->address);
	query->address = g_strdup(address);
	signal_emit("query address changed", 1, query);
}

void query_change_server __PARAM__((QUERY_REC *query, SERVER_REC *server), (query, server)) __OTORP__(QUERY_REC *query; SERVER_REC *server;){
	g_return_if_fail(IS_QUERY(query));

	if (query->server != NULL) {
		query->server->queries =
                        g_slist_remove(query->server->queries, query);
	}
	if (server != NULL)
                server->queries = g_slist_append(server->queries, query);

	query->server = server;
	signal_emit("query server changed", 1, query);
}

void queries_init __PARAM__((void), ()){
}

void queries_deinit __PARAM__((void), ()){
	module_uniq_destroy("QUERY");
}
