
/* : : generated by proto : : */
#ifndef __SERVERS_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __SERVERS_H

#include "modules.h"

/* Returns SERVER_REC if it's server, NULL if it isn't. */
#define SERVER(server) \
	MODULE_CHECK_CAST(server, SERVER_REC, type, "SERVER")

/* Returns SERVER_CONNECT_REC if it's server connection, NULL if it isn't. */
#define SERVER_CONNECT(conn) \
	MODULE_CHECK_CAST(conn, SERVER_CONNECT_REC, type, "SERVER CONNECT")

#define IS_SERVER(server) \
	(SERVER(server) ? TRUE : FALSE)

#define IS_SERVER_CONNECT(conn) \
	(SERVER_CONNECT(conn) ? TRUE : FALSE)

#define server_ischannel(server, channel) \
        (server)->ischannel(server, channel)

/* all strings should be either NULL or dynamically allocated */
/* address and nick are mandatory, rest are optional */
struct _SERVER_CONNECT_REC {
#include "server-connect-rec.h"
};

#define STRUCT_SERVER_CONNECT_REC SERVER_CONNECT_REC
struct _SERVER_REC {
#include "server-rec.h"
};

extern __MANGLE__ GSList *servers, *lookup_servers;

void servers_init __PROTO__((void));
void servers_deinit __PROTO__((void));

/* Disconnect from server */
void server_disconnect __PROTO__((SERVER_REC *server));

void server_ref __PROTO__((SERVER_REC *server));
void server_unref __PROTO__((SERVER_REC *server));

SERVER_REC *server_find_tag __PROTO__((const char *tag));
SERVER_REC *server_find_chatnet __PROTO__((const char *chatnet));

/* starts connecting to server */
int server_start_connect __PROTO__((SERVER_REC *server));
void server_connect_ref __PROTO__((SERVER_CONNECT_REC *conn));
void server_connect_unref __PROTO__((SERVER_CONNECT_REC *conn));

/* initializes server record but doesn't start connecting */
void server_connect_init __PROTO__((SERVER_REC *server));
/* Connection to server finished, fill the rest of the fields */
void server_connect_finished __PROTO__((SERVER_REC *server));
/* connection to server failed */
void server_connect_failed __PROTO__((SERVER_REC *server, const char *msg));

/* Change your nick */
void server_change_nick __PROTO__((SERVER_REC *server, const char *nick));

/* Update own IPv4 and IPv6 records */
void server_connect_own_ip_save __PROTO__((SERVER_CONNECT_REC *conn,
				IPADDR *ip4, IPADDR *ip6));

/* `optlist' should contain only one unknown key - the server tag.
   returns NULL if there was unknown -option */
SERVER_REC *cmd_options_get_server __PROTO__((const char *cmd,
				   GHashTable *optlist,
				   SERVER_REC *defserver));

#endif
