
/* : : generated by proto : : */
#ifndef __SIGNALS_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __SIGNALS_H

#define SIGNAL_MAX_ARGUMENTS 6
typedef void (*SIGNAL_FUNC)  __PROTO__((gconstpointer, gconstpointer,
			     gconstpointer, gconstpointer,
			     gconstpointer, gconstpointer));

void signals_init __PROTO__((void));
void signals_deinit __PROTO__((void));

/* signal name -> ID */
#define signal_get_uniq_id(signal) \
        module_get_uniq_id_str("signals", signal)
/* signal ID -> name */
#define signal_get_id_str(signal_id) \
	module_find_id_str("signals", signal_id)

/* bind a signal */
void signal_add_to __PROTO__((const char *module, int pos,
		   const char *signal, SIGNAL_FUNC func));
void signal_add_to_id __PROTO__((const char *module, int pos,
		      int signal, SIGNAL_FUNC func));
#define signal_add(a, b) signal_add_to(MODULE_NAME, 1, a, b)
#define signal_add_first(a, b) signal_add_to(MODULE_NAME, 0, a, b)
#define signal_add_last(a, b) signal_add_to(MODULE_NAME, 2, a, b)

/* unbind signal */
void signal_remove __PROTO__((const char *signal, SIGNAL_FUNC func));
void signal_remove_id __PROTO__((int signal_id, SIGNAL_FUNC func));

/* emit signal */
int signal_emit __PROTO__((const char *signal, int params, ...));
int signal_emit_id __PROTO__((int signal_id, int params, ...));

/* stop the current ongoing signal emission */
void signal_stop __PROTO__((void));
/* stop ongoing signal emission by signal name */
void signal_stop_by_name __PROTO__((const char *signal));

/* return the name of the signal that is currently being emitted */
const char *signal_get_emitted __PROTO__((void));
/* return the ID of the signal that is currently being emitted */
int signal_get_emitted_id __PROTO__((void));
/* return TRUE if specified signal was stopped */
int signal_is_stopped __PROTO__((int signal_id));

/* remove all signals that belong to `module' */
void signals_remove_module __PROTO__((const char *module));

#endif
