
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "signals.h"
#include "levels.h"
#include "ignore.h"

static void sig_message_public __PARAM__((SERVER_REC *server, const char *msg,
			       const char *nick, const char *address,
			       const char *target), (server, msg, nick, address, target)) __OTORP__(SERVER_REC *server; const char *msg;
			       const char *nick; const char *address;
			       const char *target;){
	if (ignore_check(server, nick, address, target, msg, MSGLEVEL_PUBLIC))
		signal_stop();
}

static void sig_message_private __PARAM__((SERVER_REC *server, const char *msg,
				const char *nick, const char *address), (server, msg, nick, address)) __OTORP__(SERVER_REC *server; const char *msg;
				const char *nick; const char *address;){
	if (ignore_check(server, nick, address, NULL, msg, MSGLEVEL_MSGS))
		signal_stop();
}

static void sig_message_join __PARAM__((SERVER_REC *server, const char *channel,
			     const char *nick, const char *address), (server, channel, nick, address)) __OTORP__(SERVER_REC *server; const char *channel;
			     const char *nick; const char *address;){
	if (ignore_check(server, nick, address, channel, NULL, MSGLEVEL_JOINS))
		signal_stop();
}

static void sig_message_part __PARAM__((SERVER_REC *server, const char *channel,
			     const char *nick, const char *address,
			     const char *reason), (server, channel, nick, address, reason)) __OTORP__(SERVER_REC *server; const char *channel;
			     const char *nick; const char *address;
			     const char *reason;){
	if (ignore_check(server, nick, address, channel, NULL, MSGLEVEL_PARTS))
		signal_stop();
}

static void sig_message_quit __PARAM__((SERVER_REC *server, const char *nick,
			     const char *address, const char *reason), (server, nick, address, reason)) __OTORP__(SERVER_REC *server; const char *nick;
			     const char *address; const char *reason;){
	if (ignore_check(server, nick, address, NULL, reason, MSGLEVEL_QUITS))
		signal_stop();
}

static void sig_message_kick __PARAM__((SERVER_REC *server, const char *channel,
			     const char *nick, const char *kicker,
			     const char *address, const char *reason), (server, channel, nick, kicker, address, reason)) __OTORP__(SERVER_REC *server; const char *channel;
			     const char *nick; const char *kicker;
			     const char *address; const char *reason;){
	if (ignore_check(server, kicker, address,
			 channel, reason, MSGLEVEL_KICKS))
		signal_stop();
}

static void sig_message_nick __PARAM__((SERVER_REC *server, const char *newnick,
			     const char *oldnick, const char *address), (server, newnick, oldnick, address)) __OTORP__(SERVER_REC *server; const char *newnick;
			     const char *oldnick; const char *address;){
	if (ignore_check(server, oldnick, address,
			 NULL, NULL, MSGLEVEL_NICKS) ||
	    ignore_check(server, newnick, address,
			 NULL, NULL, MSGLEVEL_NICKS))
		signal_stop();
}

static void sig_message_own_nick __PARAM__((SERVER_REC *server, const char *newnick,
				 const char *oldnick, const char *address), (server, newnick, oldnick, address)) __OTORP__(SERVER_REC *server; const char *newnick;
				 const char *oldnick; const char *address;){
	if (ignore_check(server, oldnick, address, NULL, NULL, MSGLEVEL_NICKS))
		signal_stop();
}

static void sig_message_invite __PARAM__((SERVER_REC *server, const char *channel,
			       const char *nick, const char *address), (server, channel, nick, address)) __OTORP__(SERVER_REC *server; const char *channel;
			       const char *nick; const char *address;){
	if (*channel == '\0' ||
	    ignore_check(server, nick, address,
			 channel, NULL, MSGLEVEL_INVITES))
		signal_stop();
}

static void sig_message_topic __PARAM__((SERVER_REC *server, const char *channel,
			      const char *topic,
			      const char *nick, const char *address), (server, channel, topic, nick, address)) __OTORP__(SERVER_REC *server; const char *channel;
			      const char *topic;
			      const char *nick; const char *address;){
	if (ignore_check(server, nick, address,
			 channel, topic, MSGLEVEL_TOPICS))
		signal_stop();
}

void fe_ignore_messages_init __PARAM__((void), ()){
	signal_add_first("message public", (SIGNAL_FUNC) sig_message_public);
	signal_add_first("message private", (SIGNAL_FUNC) sig_message_private);
	signal_add_first("message join", (SIGNAL_FUNC) sig_message_join);
	signal_add_first("message part", (SIGNAL_FUNC) sig_message_part);
	signal_add_first("message quit", (SIGNAL_FUNC) sig_message_quit);
	signal_add_first("message kick", (SIGNAL_FUNC) sig_message_kick);
	signal_add_first("message nick", (SIGNAL_FUNC) sig_message_nick);
	signal_add_first("message own_nick", (SIGNAL_FUNC) sig_message_own_nick);
	signal_add_first("message invite", (SIGNAL_FUNC) sig_message_invite);
	signal_add_first("message topic", (SIGNAL_FUNC) sig_message_topic);
}

void fe_ignore_messages_deinit __PARAM__((void), ()){
	signal_remove("message public", (SIGNAL_FUNC) sig_message_public);
	signal_remove("message private", (SIGNAL_FUNC) sig_message_private);
	signal_remove("message join", (SIGNAL_FUNC) sig_message_join);
	signal_remove("message part", (SIGNAL_FUNC) sig_message_part);
	signal_remove("message quit", (SIGNAL_FUNC) sig_message_quit);
	signal_remove("message kick", (SIGNAL_FUNC) sig_message_kick);
	signal_remove("message nick", (SIGNAL_FUNC) sig_message_nick);
	signal_remove("message own_nick", (SIGNAL_FUNC) sig_message_own_nick);
	signal_remove("message invite", (SIGNAL_FUNC) sig_message_invite);
	signal_remove("message topic", (SIGNAL_FUNC) sig_message_topic);
}
