
/* : : generated by proto : : */
#ifndef __WINDOWS_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __WINDOWS_H

#include "window-item-def.h"
#include "command-history.h"

enum {
        DATA_LEVEL_NONE = 0,
	DATA_LEVEL_TEXT,
	DATA_LEVEL_MSG,
        DATA_LEVEL_HILIGHT
};

typedef struct {
	char *servertag;
        char *name;
	unsigned int sticky:1;
} WINDOW_BIND_REC;

struct _WINDOW_REC {
	int refnum;
	char *name;

        int width, height;

	GSList *items;
	WI_ITEM_REC *active;
	SERVER_REC *active_server;
        char *servertag; /* active_server must be either NULL or have this tag (unless there's items in this window) */

	int level; /* message level */
	GSList *bound_items; /* list of WINDOW_BIND_RECs */

	unsigned int sticky_refnum:1;
	unsigned int destroying:1;

	/* window-specific command line history */
	HISTORY_REC *history;
	char *history_name;

	int data_level; /* current data level */
	char *hilight_color; /* current hilight color in %format */

	time_t last_timestamp; /* When was last timestamp printed */
	time_t last_line; /* When was last line printed */

        char *theme_name; /* active theme in window, NULL = default */
	__V_ *theme; /* THEME_REC */

	__V_ *gui_data;
};

extern __MANGLE__ GSList *windows;
extern __MANGLE__ WINDOW_REC *active_win;

WINDOW_REC *window_create __PROTO__((WI_ITEM_REC *item, int automatic));
void window_destroy __PROTO__((WINDOW_REC *window));

void window_auto_destroy __PROTO__((WINDOW_REC *window));

void window_set_active __PROTO__((WINDOW_REC *window));
void window_change_server __PROTO__((WINDOW_REC *window, __V_ *server));

void window_set_refnum __PROTO__((WINDOW_REC *window, int refnum));
void window_set_name __PROTO__((WINDOW_REC *window, const char *name));
void window_set_history __PROTO__((WINDOW_REC *window, const char *name));
void window_set_level __PROTO__((WINDOW_REC *window, int level));

/* return active item's name, or if none is active, window's name */
char *window_get_active_name __PROTO__((WINDOW_REC *window));

WINDOW_REC *window_find_level __PROTO__((__V_ *server, int level));
WINDOW_REC *window_find_closest __PROTO__((__V_ *server, const char *name, int level));
WINDOW_REC *window_find_refnum __PROTO__((int refnum));
WINDOW_REC *window_find_name __PROTO__((const char *name));
WINDOW_REC *window_find_item __PROTO__((SERVER_REC *server, const char *name));

int window_refnum_prev __PROTO__((int refnum, int wrap));
int window_refnum_next __PROTO__((int refnum, int wrap));
int windows_refnum_last __PROTO__((void));

int window_refnum_cmp __PROTO__((WINDOW_REC *w1, WINDOW_REC *w2));
GSList *windows_get_sorted __PROTO__((void));

/* Add a new bind to window - if duplicate is found it's returned */
WINDOW_BIND_REC *window_bind_add __PROTO__((WINDOW_REC *window, const char *servertag,
				 const char *name));
void window_bind_destroy __PROTO__((WINDOW_REC *window, WINDOW_BIND_REC *rec));

WINDOW_BIND_REC *window_bind_find __PROTO__((WINDOW_REC *window, const char *servertag,
				  const char *name));
void window_bind_remove_unsticky __PROTO__((WINDOW_REC *window));

void windows_init __PROTO__((void));
void windows_deinit __PROTO__((void));

#endif
