
/* : : generated by proto : : */
#ifndef __PRINTTEXT_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __PRINTTEXT_H

#include "fe-windows.h"
#include "formats.h"

void printformat_module __PROTO__((const char *module, __V_ *server, const char *target, int level, int formatnum, ...));
void printformat_module_window __PROTO__((const char *module, WINDOW_REC *window, int level, int formatnum, ...));

void printformat_module_args __PROTO__((const char *module, __V_ *server, const char *target, int level, int formatnum, va_list va));
void printformat_module_window_args __PROTO__((const char *module, WINDOW_REC *window, int level, int formatnum, va_list va));

void printtext __PROTO__((__V_ *server, const char *target, int level, const char *text, ...));
void printtext_string __PROTO__((__V_ *server, const char *target, int level, const char *text));
void printtext_string_window __PROTO__((WINDOW_REC *window, int level, const char *text));
void printtext_window __PROTO__((WINDOW_REC *window, int level, const char *text, ...));
void printtext_multiline __PROTO__((__V_ *server, const char *target, int level, const char *format, const char *text));
void printtext_dest __PROTO__((TEXT_DEST_REC *dest, const char *text, ...));

/* only GUI should call these - used for printing text to somewhere else
   than windows */
void printtext_gui __PROTO__((const char *text));
void printformat_module_gui __PROTO__((const char *module, int formatnum, ...));
void printformat_module_gui_args __PROTO__((const char *module, int formatnum, va_list va));

void printtext_init __PROTO__((void));
void printtext_deinit __PROTO__((void));

/* printformat(...) = printformat_format(MODULE_NAME, ...)

   Could this be any harder? :) With GNU C compiler and C99 compilers,
   use #define. With others use either inline functions if they are
   supported or static functions if they are not..
 */
#if defined (__GNUC__) && !defined (__STRICT_ANSI__)
/* GCC */
#if defined(__STDC__) || defined(__STDPP__)
#  define printformat(server, target, level, formatnum...) \
	printformat_module(MODULE_NAME, server, target, level, ##formatnum)
#else
#  define printformat(server, target, level, formatnum...) \
	printformat_module(MODULE_NAME, server, target, level,/**/formatnum)
#endif
#if defined(__STDC__) || defined(__STDPP__)
#  define printformat_window(window, level, formatnum...) \
	printformat_module_window(MODULE_NAME, window, level, ##formatnum)
#else
#  define printformat_window(window, level, formatnum...) \
	printformat_module_window(MODULE_NAME, window, level,/**/formatnum)
#endif
#if defined(__STDC__) || defined(__STDPP__)
#  define printformat_gui(formatnum...) \
	printformat_module_gui(MODULE_NAME, ##formatnum)
#else
#  define printformat_gui(formatnum...) \
	printformat_module_gui(MODULE_NAME,/**/formatnum)
#endif
#elif defined (_ISOC99_SOURCE)
/* C99 */
#  define printformat(server, target, level, formatnum, ...) \
	printformat_module(MODULE_NAME, server, target, level, formatnum, __VA_ARGS__)
#  define printformat_window(window, level, formatnum, ...) \
	printformat_module_window(MODULE_NAME, window, level, formatnum, __VA_ARGS__)
#  define printformat_gui(formatnum, ...) \
	printformat_module_gui(MODULE_NAME, formatnum, __VA_ARGS__)
#else
/* inline/static */
#ifdef G_CAN_INLINE
G_INLINE_FUNC
#else
static
#endif
void printformat __PARAM__((__V_ *server, const char *target, int level, int formatnum, ...), (va_alist)) __OTORP__(va_dcl)
{ __OTORP__(__V_ *server; const char *target; int level; int formatnum; )
	va_list va;

	__VA_START__(va, formatnum); __OTORP__(server = va_arg(va, __V_ *);target = va_arg(va, const char *);level = va_arg(va, int );formatnum = va_arg(va, int );)
	printformat_module_args(MODULE_NAME, server, target, level, formatnum, va);
	va_end(va);
}

#ifdef G_CAN_INLINE
G_INLINE_FUNC
#else
static
#endif
void printformat_window __PARAM__((WINDOW_REC *window, int level, int formatnum, ...), (va_alist)) __OTORP__(va_dcl)
{ __OTORP__(WINDOW_REC *window; int level; int formatnum; )
	va_list va;

	__VA_START__(va, formatnum); __OTORP__(window = va_arg(va, WINDOW_REC *);level = va_arg(va, int );formatnum = va_arg(va, int );)
	printformat_module_window_args(MODULE_NAME, window, level, formatnum, va);
	va_end(va);
}

#ifdef G_CAN_INLINE
G_INLINE_FUNC
#else
static
#endif
void printformat_gui __PARAM__((int formatnum, ...), (va_alist)) __OTORP__(va_dcl)
{ __OTORP__(int formatnum; )
	va_list va;

	__VA_START__(va, formatnum); __OTORP__(formatnum = va_arg(va, int );)
	printformat_module_gui_args(MODULE_NAME, formatnum, va);
	va_end(va);
}
#endif

#endif
