
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "module-formats.h"
#include "misc.h"
#include "settings.h"

#include "levels.h"
#include "servers.h"
#include "channels.h"
#include "queries.h"
#include "ignore.h"

#include "fe-windows.h"
#include "window-items.h"
#include "printtext.h"

static void ctcp_print __PARAM__((IRC_SERVER_REC *server,
		       const char *prefix, const char *data,
		       const char *nick, const char *addr, const char *target), (server, prefix, data, nick, addr, target)) __OTORP__(IRC_SERVER_REC *server;
		       const char *prefix; const char *data;
		       const char *nick; const char *addr; const char *target;){
	char *str;

	str = *data == '\0' ? g_strdup(prefix) :
		g_strconcat(prefix, " ", data, NULL);
	signal_emit("message irc ctcp", 5, server, str, nick, addr, target);
	g_free(str);
}

static void ctcp_default_msg __PARAM__((IRC_SERVER_REC *server, const char *data,
			     const char *nick, const char *addr,
			     const char *target), (server, data, nick, addr, target)) __OTORP__(IRC_SERVER_REC *server; const char *data;
			     const char *nick; const char *addr;
			     const char *target;){
	ctcp_print(server, "unknown CTCP", data, nick, addr, target);
}

static void ctcp_ping_msg __PARAM__((IRC_SERVER_REC *server, const char *data,
			  const char *nick, const char *addr,
			  const char *target), (server, data, nick, addr, target)) __OTORP__(IRC_SERVER_REC *server; const char *data;
			  const char *nick; const char *addr;
			  const char *target;){
	ctcp_print(server, "CTCP PING", data, nick, addr, target);
}

static void ctcp_version_msg __PARAM__((IRC_SERVER_REC *server, const char *data,
			     const char *nick, const char *addr,
			     const char *target), (server, data, nick, addr, target)) __OTORP__(IRC_SERVER_REC *server; const char *data;
			     const char *nick; const char *addr;
			     const char *target;){
	ctcp_print(server, "CTCP VERSION", data, nick, addr, target);
}

static void ctcp_time_msg __PARAM__((IRC_SERVER_REC *server, const char *data,
			  const char *nick, const char *addr,
			  const char *target), (server, data, nick, addr, target)) __OTORP__(IRC_SERVER_REC *server; const char *data;
			  const char *nick; const char *addr;
			  const char *target;){
	ctcp_print(server, "CTCP TIME", data, nick, addr, target);
}

static void ctcp_default_reply __PARAM__((IRC_SERVER_REC *server, const char *data,
			       const char *nick, const char *addr,
			       const char *target), (server, data, nick, addr, target)) __OTORP__(IRC_SERVER_REC *server; const char *data;
			       const char *nick; const char *addr;
			       const char *target;){
	const char *ctcpdata;
	char *ctcp, *ptr;

	g_return_if_fail(data != NULL);

	ctcp = g_strdup(data);
	ptr = strchr(ctcp, ' ');
	if (ptr == NULL)
		ctcpdata = "";
	else {
		*ptr = '\0';
		ctcpdata = ptr+1;
	}

	printformat(server, ischannel(*target) ? target : nick, MSGLEVEL_CTCPS,
		    ischannel(*target) ? IRCTXT_CTCP_REPLY_CHANNEL :
		    IRCTXT_CTCP_REPLY, ctcp, nick, ctcpdata, target);
	g_free(ctcp);
}

static void ctcp_ping_reply __PARAM__((IRC_SERVER_REC *server, const char *data,
			    const char *nick, const char *addr,
			    const char *target), (server, data, nick, addr, target)) __OTORP__(IRC_SERVER_REC *server; const char *data;
			    const char *nick; const char *addr;
			    const char *target;){
	GTimeVal tv, tv2;
	long usecs;

	g_return_if_fail(data != NULL);

	if (sscanf(data, "%ld %ld", &tv2.tv_sec, &tv2.tv_usec) != 2) {
                char *tmp = g_strconcat("PING ", data, NULL);
		ctcp_default_reply(server, tmp, nick, addr, target);
		g_free(tmp);
		return;
	}

        g_get_current_time(&tv);
	usecs = get_timeval_diff(&tv, &tv2);
        printformat(server, ischannel(*target) ? target : nick, MSGLEVEL_CTCPS,
                    IRCTXT_CTCP_PING_REPLY, nick, usecs/1000, usecs%1000);
}

void fe_ctcp_init __PARAM__((void), ()){
	signal_add("default ctcp msg", (SIGNAL_FUNC) ctcp_default_msg);
	signal_add("ctcp msg ping", (SIGNAL_FUNC) ctcp_ping_msg);
	signal_add("ctcp msg version", (SIGNAL_FUNC) ctcp_version_msg);
	signal_add("ctcp msg time", (SIGNAL_FUNC) ctcp_time_msg);
	signal_add("default ctcp reply", (SIGNAL_FUNC) ctcp_default_reply);
	signal_add("ctcp reply ping", (SIGNAL_FUNC) ctcp_ping_reply);
}

void fe_ctcp_deinit __PARAM__((void), ()){
	signal_remove("default ctcp msg", (SIGNAL_FUNC) ctcp_default_msg);
	signal_remove("ctcp msg ping", (SIGNAL_FUNC) ctcp_ping_msg);
	signal_remove("ctcp msg version", (SIGNAL_FUNC) ctcp_version_msg);
	signal_remove("ctcp msg time", (SIGNAL_FUNC) ctcp_time_msg);
	signal_remove("default ctcp reply", (SIGNAL_FUNC) ctcp_default_reply);
	signal_remove("ctcp reply ping", (SIGNAL_FUNC) ctcp_ping_reply);
}
