
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "module-formats.h"
#include "signals.h"
#include "levels.h"

#include "irc-servers.h"
#include "irc-channels.h"
#include "channel-rejoin.h"

#include "printtext.h"
#include "fe-windows.h"
#include "window-items.h"

static void sig_channel_rejoin __PARAM__((SERVER_REC *server, REJOIN_REC *rec), (server, rec)) __OTORP__(SERVER_REC *server; REJOIN_REC *rec;){
	g_return_if_fail(rec != NULL);

	printformat(server, NULL, MSGLEVEL_CLIENTNOTICE,
		    IRCTXT_CHANNEL_REJOIN, rec->channel);
}

static void sig_event_forward __PARAM__((SERVER_REC *server, const char *data), (server, data)) __OTORP__(SERVER_REC *server; const char *data;){
	IRC_CHANNEL_REC *channel;
	char *params, *from, *to;

	params = event_get_params(data, 3, NULL, &from, &to);
	channel = irc_channel_find(server, from);
	if (channel != NULL) {
		window_bind_add(window_item_window(channel),
				server->tag, to);
	}
	g_free(params);
}

void fe_irc_channels_init __PARAM__((void), ()){
	signal_add("channel rejoin new", (SIGNAL_FUNC) sig_channel_rejoin);
	signal_add_first("event 379", (SIGNAL_FUNC) sig_event_forward);
}

void fe_irc_channels_deinit __PARAM__((void), ()){
	signal_remove("channel rejoin new", (SIGNAL_FUNC) sig_channel_rejoin);
	signal_remove("event 379", (SIGNAL_FUNC) sig_event_forward);
}
