
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "signals.h"
#include "servers.h"
#include "queries.h"
#include "nicklist.h"

static QUERY_REC *query_find_address __PARAM__((SERVER_REC *server, const char *address), (server, address)) __OTORP__(SERVER_REC *server; const char *address;){
	GSList *tmp;

	g_return_val_if_fail(IS_SERVER(server), NULL);

	for (tmp = server->queries; tmp != NULL; tmp = tmp->next) {
		QUERY_REC *rec = tmp->data;

		if (*rec->name != '=' && rec->address != NULL &&
		    g_strcasecmp(address, rec->address) == 0)
			return rec;
	}

	return NULL;
}

static void event_privmsg __PARAM__((SERVER_REC *server, const char *data,
			  const char *nick, const char *address), (server, data, nick, address)) __OTORP__(SERVER_REC *server; const char *data;
			  const char *nick; const char *address;){
	QUERY_REC *query;

	g_return_if_fail(data != NULL);

	if (nick == NULL || address == NULL || ischannel(*data))
                return;

	query = query_find(server, nick);
	if (query == NULL) {
		/* check if there's query with another nick from the same
		   address. it was probably a nick change or reconnect to
		   server, so rename the query. */
		query = query_find_address(server, address);
		if (query != NULL)
			query_change_nick(query, nick);
	}
}

void fe_irc_queries_init __PARAM__((void), ()){
	signal_add_first("event privmsg", (SIGNAL_FUNC) event_privmsg);
}

void fe_irc_queries_deinit __PARAM__((void), ()){
	signal_remove("event privmsg", (SIGNAL_FUNC) event_privmsg);
}
