
/* : : generated by proto : : */
#ifndef __GUI_ENTRY_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __GUI_ENTRY_H

typedef struct {
	GString *text;
	int xpos, ypos, width; /* entry position in screen */
	int pos, scrstart, scrpos; /* cursor position */
        int hidden; /* print the chars as spaces in input line (useful for passwords) */

	int promptlen;
	char *prompt;

	int redraw_needed_from;
} GUI_ENTRY_REC;

extern __MANGLE__ GUI_ENTRY_REC *active_entry;

GUI_ENTRY_REC *gui_entry_create __PROTO__((int xpos, int ypos, int width));
void gui_entry_destroy __PROTO__((GUI_ENTRY_REC *entry));
void gui_entry_move __PROTO__((GUI_ENTRY_REC *entry, int xpos, int ypos, int width));

void gui_entry_set_active __PROTO__((GUI_ENTRY_REC *entry));

void gui_entry_set_prompt __PROTO__((GUI_ENTRY_REC *entry, const char *str));
void gui_entry_set_hidden __PROTO__((GUI_ENTRY_REC *entry, int hidden));

void gui_entry_set_text __PROTO__((GUI_ENTRY_REC *entry, const char *str));
char *gui_entry_get_text __PROTO__((GUI_ENTRY_REC *entry));

void gui_entry_insert_text __PROTO__((GUI_ENTRY_REC *entry, const char *str));
void gui_entry_insert_char __PROTO__((GUI_ENTRY_REC *entry, char chr));

void gui_entry_erase __PROTO__((GUI_ENTRY_REC *entry, int size));
void gui_entry_erase_word __PROTO__((GUI_ENTRY_REC *entry, int to_space));
void gui_entry_erase_next_word __PROTO__((GUI_ENTRY_REC *entry, int to_space));

int gui_entry_get_pos __PROTO__((GUI_ENTRY_REC *entry));
void gui_entry_set_pos __PROTO__((GUI_ENTRY_REC *entry, int pos));
void gui_entry_move_pos __PROTO__((GUI_ENTRY_REC *entry, int pos));
void gui_entry_move_words __PROTO__((GUI_ENTRY_REC *entry, int count, int to_space));

void gui_entry_redraw __PROTO__((GUI_ENTRY_REC *entry));

#endif
