
/* : : generated by proto : : */
#ifndef __STATUSBAR_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __STATUSBAR_H

#include "mainwindows.h"

#define STATUSBAR_PRIORITY_HIGH		100
#define STATUSBAR_PRIORITY_NORMAL	0
#define STATUSBAR_PRIORITY_LOW		-100

typedef struct SBAR_ITEM_REC SBAR_ITEM_REC;
typedef void (*STATUSBAR_FUNC)  __PROTO__((SBAR_ITEM_REC *item, int get_size_only));

/* type */
#define STATUSBAR_TYPE_ROOT	1
#define STATUSBAR_TYPE_WINDOW	2

/* placement */
#define STATUSBAR_TOP		1
#define STATUSBAR_BOTTOM	2

/* visible */
#define STATUSBAR_VISIBLE_ALWAYS        1
#define STATUSBAR_VISIBLE_ACTIVE        2
#define STATUSBAR_VISIBLE_INACTIVE      3

typedef struct {
	char *name;
        GSList *config_bars;
	GSList *bars;
} STATUSBAR_GROUP_REC;

typedef struct {
	char *name;

	int type; /* root/window */
	int placement; /* top/bottom */
	int position; /* the higher the number, the lower it is in screen */
	int visible; /* active/inactive/always */

	GSList *items;
} STATUSBAR_CONFIG_REC;

typedef struct {
	STATUSBAR_GROUP_REC *group;
	STATUSBAR_CONFIG_REC *config;

	MAIN_WINDOW_REC *parent_window; /* if config->type == STATUSBAR_TYPE_WINDOW */
        GSList *items;

	char *color; /* background color */
	int real_ypos; /* real Y-position in screen at the moment */

	int dirty:1;
        int dirty_xpos; /* -1 = only redraw some items, >= 0 = redraw all items after from xpos */
} STATUSBAR_REC;

typedef struct {
	char *name;
	char *value; /* if non-NULL, overrides the default */

	int priority;
	unsigned int right_alignment:1;
} SBAR_ITEM_CONFIG_REC;

struct SBAR_ITEM_REC {
	STATUSBAR_REC *bar;
	SBAR_ITEM_CONFIG_REC *config;
        STATUSBAR_FUNC func;

	/* what item wants */
	int min_size, max_size;

	/* what item gets */
	int xpos, size;

        int current_size; /* item size currently in screen */
	int dirty:1;
};

extern __MANGLE__ GSList *statusbar_groups;
extern __MANGLE__ STATUSBAR_GROUP_REC *active_statusbar_group;

void statusbar_item_register __PROTO__((const char *name, const char *value,
			     STATUSBAR_FUNC func));
void statusbar_item_unregister __PROTO__((const char *name));

STATUSBAR_GROUP_REC *statusbar_group_create __PROTO__((const char *name));
void statusbar_group_destroy __PROTO__((STATUSBAR_GROUP_REC *rec));
STATUSBAR_GROUP_REC *statusbar_group_find __PROTO__((const char *name));

STATUSBAR_REC *statusbar_create __PROTO__((STATUSBAR_GROUP_REC *group,
                                STATUSBAR_CONFIG_REC *config,
                                MAIN_WINDOW_REC *parent_window));
void statusbar_destroy __PROTO__((STATUSBAR_REC *bar));
STATUSBAR_REC *statusbar_find __PROTO__((STATUSBAR_GROUP_REC *group, const char *name,
			      MAIN_WINDOW_REC *window));

SBAR_ITEM_REC *statusbar_item_create __PROTO__((STATUSBAR_REC *bar,
				     SBAR_ITEM_CONFIG_REC *config));
void statusbar_item_destroy __PROTO__((SBAR_ITEM_REC *item));

void statusbar_item_default_handler __PROTO__((SBAR_ITEM_REC *item, int get_size_only,
				    const char *str, const char *data,
				    int escape_vars));

/* redraw statusbar, NULL = all */
void statusbar_redraw __PROTO__((STATUSBAR_REC *bar, int force));
void statusbar_item_redraw __PROTO__((SBAR_ITEM_REC *item));
void statusbar_items_redraw __PROTO__((const char *name));

void statusbar_recreate_items __PROTO__((STATUSBAR_REC *bar));
void statusbars_recreate_items __PROTO__((void));

void statusbar_redraw_dirty __PROTO__((void));

void statusbar_init __PROTO__((void));
void statusbar_deinit __PROTO__((void));

#endif
