
/* : : generated by proto : : */
#ifndef __TERM_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __TERM_H

typedef struct _TERM_WINDOW TERM_WINDOW;

#define ATTR_RESETFG	0x0100
#define ATTR_RESETBG	0x0200
#define ATTR_BOLD	0x0400
#define ATTR_BLINK      0x0800
#define ATTR_UNDERLINE	0x1000
#define ATTR_REVERSE	0x2000

#define ATTR_RESET	(ATTR_RESETFG|ATTR_RESETBG)

#define ATTR_NOCOLORS (ATTR_UNDERLINE|ATTR_REVERSE)

#ifdef WANT_BIG5
/* XXX I didn't check the encoding range of big5+. This is standard big5. */
#  define is_big5_los(lo) (((char)0x40<=lo)&&(lo<=(char)0x7E))	/* standard */
#  define is_big5_lox(lo) (((char)0x80<=lo)&&(lo<=(char)0xFE))	/* extended */
#  define is_big5_hi(hi)  (((char)0x81<=hi)&&(hi<=(char)0xFE))
#  define is_big5(hi,lo) is_big5_hi(hi) && (is_big5_los(lo) || is_big5_lox(lo))
#endif

extern __MANGLE__ TERM_WINDOW *root_window;
extern __MANGLE__ int term_width, term_height, term_use_colors, term_detached;

/* Initialize / deinitialize terminal */
int term_init __PROTO__((void));
void term_deinit __PROTO__((void));

/* Resize terminal - if width or height is negative,
   the new size is unknown and should be figured out somehow */
void term_resize __PROTO__((int width, int height));
void term_resize_final __PROTO__((int width, int height));
/* Resize the terminal if needed */
void term_resize_dirty __PROTO__((void));

/* Returns TRUE if terminal has colors */
int term_has_colors __PROTO__((void));
/* Force the colors on any way you can */
void term_force_colors __PROTO__((int set));

/* Clear screen */
void term_clear __PROTO__((void));
/* Beep */
void term_beep __PROTO__((void));

/* Create a new window in terminal */
TERM_WINDOW *term_window_create __PROTO__((int x, int y, int width, int height));
/* Destroy a terminal window */
void term_window_destroy __PROTO__((TERM_WINDOW *window));

/* Move/resize window */
void term_window_move __PROTO__((TERM_WINDOW *window, int x, int y,
		      int width, int height));
/* Clear window */
void term_window_clear __PROTO__((TERM_WINDOW *window));
/* Scroll window up/down */
void term_window_scroll __PROTO__((TERM_WINDOW *window, int count));

void term_set_color __PROTO__((TERM_WINDOW *window, int col));

void term_move __PROTO__((TERM_WINDOW *window, int x, int y));
void term_addch __PROTO__((TERM_WINDOW *window, int chr));
void term_addstr __PROTO__((TERM_WINDOW *window, const char *str));
void term_clrtoeol __PROTO__((TERM_WINDOW *window));

void term_move_cursor __PROTO__((int x, int y));

void term_refresh_freeze __PROTO__((void));
void term_refresh_thaw __PROTO__((void));
void term_refresh __PROTO__((TERM_WINDOW *window));

/* Automatically detach irssi when terminal is lost */
void term_auto_detach __PROTO__((int set));
void term_detach __PROTO__((void));
void term_attach __PROTO__((FILE *in, FILE *out));

void term_stop __PROTO__((void));
int term_gets __PROTO__((unsigned char *buffer, int size));

/* internal */
void term_common_init __PROTO__((void));
void term_common_deinit __PROTO__((void));

#endif
