
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "chat-protocols.h"

#include "irc-servers.h"
#include "irc-chatnets.h"
#include "irc-channels.h"
#include "irc-queries.h"

#include "irc-servers-setup.h"
#include "channels-setup.h"

#include "ctcp.h"
#include "irc-commands.h"
#include "netsplit.h"

void irc_expandos_init __PROTO__((void));
void irc_expandos_deinit __PROTO__((void));

void irc_session_init __PROTO__((void));
void irc_session_deinit __PROTO__((void));

void lag_init __PROTO__((void));
void lag_deinit __PROTO__((void));

static CHATNET_REC *create_chatnet __PARAM__((void), ()){
        return g_malloc0(sizeof(IRC_CHATNET_REC));
}

static SERVER_SETUP_REC *create_server_setup __PARAM__((void), ()){
        return g_malloc0(sizeof(IRC_SERVER_SETUP_REC));
}

static CHANNEL_SETUP_REC *create_channel_setup __PARAM__((void), ()){
        return g_malloc0(sizeof(CHANNEL_SETUP_REC));
}

static SERVER_CONNECT_REC *create_server_connect __PARAM__((void), ()){
        return g_malloc0(sizeof(IRC_SERVER_CONNECT_REC));
}

static void destroy_server_connect __PARAM__((SERVER_CONNECT_REC *conn), (conn)) __OTORP__(SERVER_CONNECT_REC *conn;){
	IRC_SERVER_CONNECT_REC *ircconn;

        ircconn = IRC_SERVER_CONNECT(conn);
	if (ircconn == NULL)
		return;

	g_free_not_null(ircconn->usermode);
	g_free_not_null(ircconn->alternate_nick);
}

void irc_core_init __PARAM__((void), ()){
	CHAT_PROTOCOL_REC *rec;

	rec = g_new0(CHAT_PROTOCOL_REC, 1);
	rec->name = "IRC";
	rec->fullname = "Internet Relay Chat";
	rec->chatnet = "ircnet";

        rec->case_insensitive = TRUE;

	rec->create_chatnet = create_chatnet;
        rec->create_server_setup = create_server_setup;
        rec->create_channel_setup = create_channel_setup;
	rec->create_server_connect = create_server_connect;
	rec->destroy_server_connect = destroy_server_connect;

	rec->server_connect = 
		irc_server_connect;
	rec->channel_create =
                irc_channel_create;
	rec->query_create =
                irc_query_create;

	chat_protocol_register(rec);
        g_free(rec);

        irc_session_init();
	irc_chatnets_init();
	irc_servers_init();
	irc_channels_init();
	irc_queries_init();

	ctcp_init();
	irc_commands_init();
	irc_irc_init();
	lag_init();
	netsplit_init();
	irc_expandos_init();

	module_register("core", "irc");
}

void irc_core_deinit __PARAM__((void), ()){
	signal_emit("chat protocol deinit", 1, chat_protocol_find("IRC"));

	irc_expandos_deinit();
	netsplit_deinit();
	lag_deinit();
	irc_commands_deinit();
	ctcp_deinit();

	irc_queries_deinit();
	irc_channels_deinit();
	irc_irc_deinit();
	irc_servers_deinit();
	irc_chatnets_deinit();
        irc_session_deinit();

	chat_protocol_unregister("IRC");
}
