
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "misc.h"
#include "expandos.h"
#include "settings.h"

#include "irc-servers.h"
#include "channels.h"
#include "nicklist.h"

static char *last_join;

/* last person to join a channel you are on */
static char *expando_lastjoin __PARAM__((SERVER_REC *server, __V_ *item, int *free_ret), (server, item, free_ret)) __OTORP__(SERVER_REC *server; __V_ *item; int *free_ret;){
	return last_join;
}

/* current server numeric being processed */
static char *expando_server_numeric __PARAM__((SERVER_REC *server, __V_ *item, int *free_ret), (server, item, free_ret)) __OTORP__(SERVER_REC *server; __V_ *item; int *free_ret;){
	return current_server_event == NULL ||
		!is_numeric(current_server_event, 0) ? NULL :
		current_server_event;
}

/* current server name */
static char *expando_servername __PARAM__((SERVER_REC *server, __V_ *item, int *free_ret), (server, item, free_ret)) __OTORP__(SERVER_REC *server; __V_ *item; int *free_ret;){
	IRC_SERVER_REC *ircserver = IRC_SERVER(server);

	return ircserver == NULL ? "" : ircserver->real_address;
}

/* your /userhost $N address (user@host) */
static char *expando_userhost __PARAM__((SERVER_REC *server, __V_ *item, int *free_ret), (server, item, free_ret)) __OTORP__(SERVER_REC *server; __V_ *item; int *free_ret;){
	IRC_SERVER_REC *ircserver;
	const char *username;
	char hostname[100];

	ircserver = IRC_SERVER(server);

	/* prefer the _real_ /userhost reply */
	if (ircserver != NULL && ircserver->userhost != NULL)
		return ircserver->userhost;

	/* haven't received userhost reply yet. guess something */
	*free_ret = TRUE;
	if (server == NULL)
		username = settings_get_str("user_name");
	else
		username = ircserver->connrec->username;

	if (gethostname(hostname, sizeof(hostname)) != 0 || *hostname == '\0')
		strcpy(hostname, "??");
	return g_strconcat(username, "@", hostname, NULL);;
}

/* user mode in active server */
static char *expando_usermode __PARAM__((SERVER_REC *server, __V_ *item, int *free_ret), (server, item, free_ret)) __OTORP__(SERVER_REC *server; __V_ *item; int *free_ret;){
	return IS_IRC_SERVER(server) ? IRC_SERVER(server)->usermode : "";
}

/* expands to your usermode on channel, op '@', halfop '%', "+" voice */
static char *expando_cumode __PARAM__((SERVER_REC *server, __V_ *item, int *free_ret), (server, item, free_ret)) __OTORP__(SERVER_REC *server; __V_ *item; int *free_ret;){
	if (IS_CHANNEL(item) && CHANNEL(item)->ownnick) {
		return NICK(CHANNEL(item)->ownnick)->op ? "@" :
		       NICK(CHANNEL(item)->ownnick)->halfop ? "%" :
		       NICK(CHANNEL(item)->ownnick)->voice ? "+" : "";
	}
	return "";
}

/* expands to your usermode on channel,
   op '@', halfop '%', "+" voice, " " normal */
static char *expando_cumode_space __PARAM__((SERVER_REC *server, __V_ *item, int *free_ret), (server, item, free_ret)) __OTORP__(SERVER_REC *server; __V_ *item; int *free_ret;){
	char *ret;
	
	ret = expando_cumode(server, item, free_ret);
	return *ret == '\0' ? " " : ret;
}

static void event_join __PARAM__((IRC_SERVER_REC *server, const char *data,
		       const char *nick, const char *address), (server, data, nick, address)) __OTORP__(IRC_SERVER_REC *server; const char *data;
		       const char *nick; const char *address;){
	g_return_if_fail(nick != NULL);

	if (g_strcasecmp(nick, server->nick) != 0) {
		g_free_not_null(last_join);
		last_join = g_strdup(nick);
	}
}

void irc_expandos_init __PARAM__((void), ()){
	last_join = NULL;

	expando_create(":", expando_lastjoin,
		       "event join", EXPANDO_ARG_SERVER, NULL);
	expando_create("H", expando_server_numeric,
		       "server event", EXPANDO_ARG_SERVER, NULL);
	expando_create("S", expando_servername,
		       "window changed", EXPANDO_ARG_NONE,
		       "window server changed", EXPANDO_ARG_WINDOW, NULL);
	expando_create("X", expando_userhost,
		       "window changed", EXPANDO_ARG_NONE,
		       "window server changed", EXPANDO_ARG_WINDOW, NULL);
	expando_create("usermode", expando_usermode,
		       "window changed", EXPANDO_ARG_NONE,
		       "window server changed", EXPANDO_ARG_WINDOW,
		       "user mode changed", EXPANDO_ARG_SERVER, NULL);
	expando_create("cumode", expando_cumode,
		       "window changed", EXPANDO_ARG_NONE,
		       "window item changed", EXPANDO_ARG_WINDOW,
		       "nick mode changed", EXPANDO_ARG_WINDOW_ITEM, NULL);
	expando_create("cumode_space", expando_cumode_space,
		       "window changed", EXPANDO_ARG_NONE,
		       "window item changed", EXPANDO_ARG_WINDOW,
		       "nick mode changed", EXPANDO_ARG_WINDOW_ITEM, NULL);

        expando_add_signal("I", "event invite", EXPANDO_ARG_SERVER);

	signal_add("event join", (SIGNAL_FUNC) event_join);
}

void irc_expandos_deinit __PARAM__((void), ()){
	g_free_not_null(last_join);

	expando_destroy(":", expando_lastjoin);
	expando_destroy("H", expando_server_numeric);
	expando_destroy("S", expando_servername);
	expando_destroy("X", expando_userhost);
	expando_destroy("usermode", expando_usermode);
	expando_destroy("cumode", expando_cumode);

	signal_remove("event join", (SIGNAL_FUNC) event_join);
}
