
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "signals.h"
#include "misc.h"

#include "irc-servers.h"
#include "irc-queries.h"

QUERY_REC *irc_query_create __PARAM__((const char *server_tag,
			    const char *nick, int automatic), (server_tag, nick, automatic)) __OTORP__(const char *server_tag;
			    const char *nick; int automatic;){
	QUERY_REC *rec;

	g_return_val_if_fail(nick != NULL, NULL);

	rec = g_new0(QUERY_REC, 1);
	rec->chat_type = IRC_PROTOCOL;
	rec->name = g_strdup(nick);
        rec->server_tag = g_strdup(server_tag);
	query_init(rec, automatic);
	return rec;
}

static void event_privmsg __PARAM__((IRC_SERVER_REC *server, const char *data,
			  const char *nick, const char *address), (server, data, nick, address)) __OTORP__(IRC_SERVER_REC *server; const char *data;
			  const char *nick; const char *address;){
	QUERY_REC *query;
	char *params, *target, *msg;

	g_return_if_fail(data != NULL);

	params = event_get_params(data, 2 | PARAM_FLAG_GETREST, &target, &msg);

	if (address != NULL && !ischannel(*target)) {
		/* save nick's address to query */
		query = irc_query_find(server, nick);
		if (query != NULL && (query->address == NULL ||
				      strcmp(query->address, address) != 0))
                        query_change_address(query, address);
	}

	g_free(params);
}

static void event_nick __PARAM__((SERVER_REC *server, const char *data,
		       const char *orignick), (server, data, orignick)) __OTORP__(SERVER_REC *server; const char *data;
		       const char *orignick;){
        QUERY_REC *query;
	char *params, *nick;

	query = query_find(server, orignick);
	if (query != NULL) {
		params = event_get_params(data, 1, &nick);
		query_change_nick(query, nick);
		g_free(params);
	}
}

void irc_queries_init __PARAM__((void), ()){
	signal_add_last("event privmsg", (SIGNAL_FUNC) event_privmsg);
	signal_add("event nick", (SIGNAL_FUNC) event_nick);
}

void irc_queries_deinit __PARAM__((void), ()){
	signal_remove("event privmsg", (SIGNAL_FUNC) event_privmsg);
	signal_remove("event nick", (SIGNAL_FUNC) event_nick);
}
