
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "misc.h"
#include "signals.h"

#include "irc-servers.h"
#include "irc-channels.h"
#include "mode-lists.h"

static void ban_free __PARAM__((GSList **list, BAN_REC *rec), (list, rec)) __OTORP__(GSList **list; BAN_REC *rec;){
	g_return_if_fail(list != NULL);
	g_return_if_fail(rec != NULL);

	g_free(rec->ban);
	g_free_not_null(rec->setby);
	g_free(rec);

	*list = g_slist_remove(*list, rec);
}

void banlist_free __PARAM__((GSList *banlist), (banlist)) __OTORP__(GSList *banlist;){
	while (banlist != NULL)
		ban_free(&banlist, banlist->data);
}

BAN_REC *banlist_add __PARAM__((IRC_CHANNEL_REC *channel, const char *ban,
		     const char *nick, time_t time), (channel, ban, nick, time)) __OTORP__(IRC_CHANNEL_REC *channel; const char *ban;
		     const char *nick; time_t time;){
	BAN_REC *rec;

	g_return_val_if_fail(channel != NULL, NULL);
	g_return_val_if_fail(ban != NULL, NULL);

	rec = g_new(BAN_REC, 1);
	rec->ban = g_strdup(ban);
	rec->setby = nick == NULL || *nick == '\0' ? NULL :
		g_strdup(nick);
	rec->time = time;

	channel->banlist = g_slist_append(channel->banlist, rec);

	signal_emit("ban new", 2, channel, rec);
	return rec;
}

static BAN_REC *banlist_find __PARAM__((GSList *list, const char *ban), (list, ban)) __OTORP__(GSList *list; const char *ban;){
	GSList *tmp;

	g_return_val_if_fail(ban != NULL, NULL);

	for (tmp = list; tmp != NULL; tmp = tmp->next) {
		BAN_REC *rec = tmp->data;

		if (g_strcasecmp(rec->ban, ban) == 0)
			return rec;
	}

	return NULL;
}

void banlist_remove __PARAM__((IRC_CHANNEL_REC *channel, const char *ban), (channel, ban)) __OTORP__(IRC_CHANNEL_REC *channel; const char *ban;){
	BAN_REC *rec;

	g_return_if_fail(channel != NULL);
	g_return_if_fail(ban != NULL);

	rec = banlist_find(channel->banlist, ban);
	if (rec != NULL) {
		signal_emit("ban remove", 2, channel, rec);
		ban_free(&channel->banlist, rec);
	}
}

static void channel_destroyed __PARAM__((IRC_CHANNEL_REC *channel), (channel)) __OTORP__(IRC_CHANNEL_REC *channel;){
	if (!IS_IRC_CHANNEL(channel))
                return;

	banlist_free(channel->banlist);
}

static void event_banlist __PARAM__((IRC_SERVER_REC *server, const char *data), (server, data)) __OTORP__(IRC_SERVER_REC *server; const char *data;){
	IRC_CHANNEL_REC *chanrec;
	char *params, *channel, *ban, *setby, *tims;
	time_t tim;

	g_return_if_fail(data != NULL);

	params = event_get_params(data, 5, NULL, &channel, &ban, &setby, &tims);
	chanrec = irc_channel_find(server, channel);
	if (chanrec != NULL) {
		tim = (time_t) atol(tims);
		banlist_add(chanrec, ban, setby, tim);
	}
	g_free(params);
}

void mode_lists_init __PARAM__((void), ()){
	signal_add("channel destroyed", (SIGNAL_FUNC) channel_destroyed);

	signal_add("chanquery ban", (SIGNAL_FUNC) event_banlist);
}

void mode_lists_deinit __PARAM__((void), ()){
	signal_remove("channel destroyed", (SIGNAL_FUNC) channel_destroyed);

	signal_remove("chanquery ban", (SIGNAL_FUNC) event_banlist);
}
