
/* : : generated by proto : : */
#ifndef __MODES_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __MODES_H

/* modes that have argument always */
#define HAS_MODE_ARG_ALWAYS(mode) \
	((mode) == 'b' || (mode) == 'e' || (mode) == 'I' || (mode) == 'q' || \
        (mode) == 'd' || (mode) == 'o' || (mode) == 'h' || (mode) == 'v' || \
        (mode) == 'O' || (mode) == 'k')

/* modes that have argument when being set (+) */
#define HAS_MODE_ARG_SET(mode) \
	(HAS_MODE_ARG_ALWAYS(mode) || (mode) == 'l')

/* modes that have argument when being unset (-) */
#define HAS_MODE_ARG_UNSET(mode) \
	HAS_MODE_ARG_ALWAYS(mode)

#define HAS_MODE_ARG(type, mode) \
	((type) == '+' ? HAS_MODE_ARG_SET(mode) : HAS_MODE_ARG_UNSET(mode))

void modes_init __PROTO__((void));
void modes_deinit __PROTO__((void));

/* add `mode' to `old' - return newly allocated mode.
   `channel' specifies if we're parsing channel mode and we should try
   to join mode arguments too. */
char *modes_join __PROTO__((const char *old, const char *mode, int channel));

int channel_mode_is_set __PROTO__((IRC_CHANNEL_REC *channel, char mode));

void parse_channel_modes __PROTO__((IRC_CHANNEL_REC *channel, const char *setby,
			 const char *modestr));

void channel_set_singlemode __PROTO__((IRC_CHANNEL_REC *channel, const char *nicks,
			    const char *mode));
void channel_set_mode __PROTO__((IRC_SERVER_REC *server, const char *channel,
		      const char *mode));

#endif
