
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "signals.h"
#include "masks.h"
#include "settings.h"
#include "servers.h"

#include "dcc-get.h"

static void sig_dcc_request __PARAM__((GET_DCC_REC *dcc, const char *nickaddr), (dcc, nickaddr)) __OTORP__(GET_DCC_REC *dcc; const char *nickaddr;){
        struct stat statbuf;
	const char *masks;
        char *str, *file;
        int max_size;

        if (!IS_DCC_GET(dcc)) return;

	/* check if we want to autoget file offer */
	if (!settings_get_bool("dcc_autoget") &&
	    !settings_get_bool("dcc_autoresume"))
		return;

	/* check for lowports */
	if (dcc->port < 1024 && !settings_get_bool("dcc_autoaccept_lowports"))
                return;

	/* check that autoget masks match */
	masks = settings_get_str("dcc_autoget_masks");
	if (*masks != '\0' &&
	    !masks_match(SERVER(dcc->server), masks, dcc->nick, nickaddr))
		return;

	/* check file size limit, NOTE: it's still possible to send a
	   bogus file size and then just send what ever sized file.. */
        max_size = settings_get_int("dcc_autoget_max_size");
	if (max_size > 0 && (unsigned long) max_size*1024 < dcc->size)
                return;

	/* ok. but do we want/need to resume? */
	file = dcc_get_download_path(dcc->arg);
	str = g_strdup_printf(settings_get_bool("dcc_autoresume") &&
			      stat(file, &statbuf) == 0 ?
			      "RESUME %s %s" : "GET %s %s",
			      dcc->nick, dcc->arg);
	signal_emit("command dcc", 2, str, dcc->server);
        g_free(file);
	g_free(str);
}

void dcc_autoget_init __PARAM__((void), ()){
	settings_add_bool("dcc", "dcc_autoget", FALSE);
	settings_add_bool("dcc", "dcc_autoaccept_lowports", FALSE);
	settings_add_bool("dcc", "dcc_autoresume", FALSE);
	settings_add_int("dcc", "dcc_autoget_max_size", 1000);
	settings_add_str("dcc", "dcc_autoget_masks", "");

	signal_add_last("dcc request", (SIGNAL_FUNC) sig_dcc_request);
}

void dcc_autoget_deinit __PARAM__((void), ()){
	signal_remove("dcc request", (SIGNAL_FUNC) sig_dcc_request);
}
