
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "common.h"
#include "irc.h"

#define MODULE_NAME "irc/notifylist"

typedef struct {
	char *nick;
	char *user, *host, *realname, *awaymsg;
	int idle_time;

	unsigned int host_ok:1; /* host matches the one in notifylist = this is the right person*/
	unsigned int away_ok:1; /* not away, or we don't care about it */
	unsigned int idle_ok:1; /* idle time is low enough, or we don't care about it */

	unsigned int away:1; /* nick is away */
	unsigned int join_announced:1; /* join to IRC has been announced */
	unsigned int idle_changed:1; /* idle time is lower than in last check */

	time_t last_whois;
} NOTIFY_NICK_REC;

typedef struct {
	int ison_count; /* number of ISON requests sent */

	GSList *notify_users; /* NOTIFY_NICK_REC's of notifylist people who are in IRC */
	GSList *ison_tempusers; /* Temporary list for saving /ISON events.. */
} MODULE_SERVER_REC;

#include "irc-servers.h"

NOTIFY_NICK_REC *notify_nick_create __PROTO__((IRC_SERVER_REC *server, const char *nick));
void notify_nick_destroy __PROTO__((NOTIFY_NICK_REC *rec));
NOTIFY_NICK_REC *notify_nick_find __PROTO__((IRC_SERVER_REC *server, const char *nick));

void notifylist_left __PROTO__((IRC_SERVER_REC *server, NOTIFY_NICK_REC *rec));
void notifylist_destroy_all __PROTO__((void));

void notifylist_commands_init __PROTO__((void));
void notifylist_commands_deinit __PROTO__((void));

void notifylist_whois_init __PROTO__((void));
void notifylist_whois_deinit __PROTO__((void));

void notifylist_ison_init __PROTO__((void));
void notifylist_ison_deinit __PROTO__((void));
