
/* : : generated by proto : : */
#ifndef __NOTIFYLIST_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __NOTIFYLIST_H

typedef struct {
	char *mask; /* nick part must not contain wildcards */
	char **ircnets; /* if non-NULL, check only from these irc networks */

	/* notify when AWAY status changes (uses /USERHOST) */
	unsigned int away_check:1;
	/* notify when idle time is reset and it was bigger than this
	   (uses /WHOIS and PRIVMSG events) */
	int idle_check_time;
} NOTIFYLIST_REC;

extern __MANGLE__ GSList *notifies;

void notifylist_init __PROTO__((void));
void notifylist_deinit __PROTO__((void));

NOTIFYLIST_REC *notifylist_add __PROTO__((const char *mask, const char *ircnets,
			       int away_check, int idle_check_time));
void notifylist_remove __PROTO__((const char *mask));

IRC_SERVER_REC *notifylist_ison __PROTO__((const char *nick, const char *serverlist));
int notifylist_ison_server __PROTO__((IRC_SERVER_REC *server, const char *nick));

/* If `ircnet' is "*", it doesn't matter at all. */
NOTIFYLIST_REC *notifylist_find __PROTO__((const char *mask, const char *ircnet));

int notifylist_ircnets_match __PROTO__((NOTIFYLIST_REC *rec, const char *ircnet));

#endif
