
/* : : generated by proto : : */
#ifndef __PERL_COMMON_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __PERL_COMMON_H

/* helper defines */
#define new_pv(a) \
	(newSVpv((a) == NULL ? "" : (a), (a) == NULL ? 0 : strlen(a)))

#define is_hvref(o) \
	((o) && SvROK(o) && SvRV(o) && (SvTYPE(SvRV(o)) == SVt_PVHV))

#define hvref(o) \
	(is_hvref(o) ? (HV *)SvRV(o) : NULL)

typedef void (*PERL_OBJECT_FUNC)  __PROTO__((HV *hv, __V_ *object));

typedef struct {
	char *name;
        PERL_OBJECT_FUNC fill_func;
} PLAIN_OBJECT_INIT_REC;

/* Returns the package who called us */
const char *perl_get_package __PROTO__((void));
/* Parses the package part from function name */
char *perl_function_get_package __PROTO__((const char *function));
/* If SV is a string, prefix it with given package.
   Increases the reference counter for the return value. */
SV *perl_func_sv_inc __PROTO__((SV *func, const char *package));

/* For compatibility with perl 5.004 and older */
#ifndef HAVE_PL_PERL
#  define PL_sv_undef sv_undef
extern __MANGLE__ STRLEN PL_na;
#endif

#define iobject_bless(object) \
	((object) == NULL ? &PL_sv_undef : \
	irssi_bless_iobject((object)->type, (object)->chat_type, object))

#define simple_iobject_bless(object) \
	((object) == NULL ? &PL_sv_undef : \
	irssi_bless_iobject((object)->type, 0, object))

#define plain_bless(object, stash) \
	((object) == NULL ? &PL_sv_undef : \
	irssi_bless_plain(stash, object))

SV *irssi_bless_iobject __PROTO__((int type, int chat_type, __V_ *object));
SV *irssi_bless_plain __PROTO__((const char *stash, __V_ *object));
int irssi_is_ref_object __PROTO__((SV *o));
__V_ *irssi_ref_object __PROTO__((SV *o));

void irssi_add_object __PROTO__((int type, int chat_type, const char *stash,
		      PERL_OBJECT_FUNC func));
void irssi_add_plain __PROTO__((const char *stash, PERL_OBJECT_FUNC func));
void irssi_add_plains __PROTO__((PLAIN_OBJECT_INIT_REC *objects));

char *perl_get_use_list __PROTO__((void));

#if defined(__STDC__) || defined(__STDPP__)
#define irssi_boot(x) { \
	extern void boot_Irssi__##x(CV *cv); \
	irssi_callXS(boot_Irssi__##x, cv, mark); \
	}
#else
#define irssi_boot(x) { \
	extern void boot_Irssi__/**/x(CV *cv); \
	irssi_callXS(boot_Irssi__/**/x, cv, mark); \
	}
#endif
void irssi_callXS __PROTO__((void (*subaddr)(CV* cv), CV *cv, SV **mark));

void perl_common_start __PROTO__((void));
void perl_common_stop __PROTO__((void));

#endif
