
/* : : generated by proto : : */
#ifndef __PERL_CORE_H
#if !defined(__PROTO__)
#include <prototyped.h>
#endif

#define __PERL_CORE_H

typedef struct {
	char *name; /* unique name */
        char *package; /* package name */

        /* Script can be loaded from a file, or from some data in memory */
	char *path; /* FILE: full path for file */
	char *data; /* DATA: data used for the script */
} PERL_SCRIPT_REC;

extern __MANGLE__ GSList *perl_scripts;

/* Initialize perl interpreter */
void perl_scripts_init __PROTO__((void));
/* Destroy all perl scripts and deinitialize perl interpreter */
void perl_scripts_deinit __PROTO__((void));

/* Load a perl script, path must be a full path. */
PERL_SCRIPT_REC *perl_script_load_file __PROTO__((const char *path));
/* Load a perl script from given data */
PERL_SCRIPT_REC *perl_script_load_data __PROTO__((const char *data));
/* Unload perl script */
void perl_script_unload __PROTO__((PERL_SCRIPT_REC *script));

/* Find loaded script by name */
PERL_SCRIPT_REC *perl_script_find __PROTO__((const char *name));
/* Find loaded script by package */
PERL_SCRIPT_REC *perl_script_find_package __PROTO__((const char *package));

/* Returns full path for the script */
char *perl_script_get_path __PROTO__((const char *name));
/* Modify the script name so that all non-alphanumeric characters are
   translated to '_' */
void script_fix_name __PROTO__((char *name));

/* If core should handle printing script errors */
void perl_core_print_script_error __PROTO__((int print));

/* Returns the perl module's API version. */
int perl_get_api_version __PROTO__((void));

/* Checks that the API version is correct. */
#define perl_api_version_check(library) \
	if (perl_get_api_version() != IRSSI_PERL_API_VERSION) { \
		die("Version of perl module (%d) doesn't match the " \
		    "version of "library" library (%d)", \
		    perl_get_api_version(), IRSSI_PERL_API_VERSION); \
		return; \
        }

void perl_core_init __PROTO__((void));
void perl_core_deinit __PROTO__((void));

#endif
