
/* : : generated by proto : : */

#if !defined(__PROTO__)
#include <prototyped.h>
#endif
#include "module.h"
#include "signals.h"
#include "commands.h"

#include "irc.h"
#include "irc-servers.h"
#include "channels.h"
#include "nicklist.h"
#include "masks.h"

#include "bot-users.h"
#include "botnet.h"

void botcmd_user_add __PARAM__((const char *nick), (nick)) __OTORP__(const char *nick;){
	char *str;

	botuser_add(nick);

	str = g_strdup_printf("USER_ADD %s", nick);
	botnet_broadcast(NULL, NULL, NULL, str);
	g_free(str);
}

void botcmd_user_set_flags __PARAM__((USER_REC *user, int flags), (user, flags)) __OTORP__(USER_REC *user; int flags;){
	char *str, *flagstr;

	botuser_set_flags(user, flags);

	flagstr = botuser_value2flags(flags);
	str = g_strdup_printf("USER_FLAGS %s %s", user->nick, flagstr);
	g_free(flagstr);

	botnet_broadcast(NULL, NULL, NULL, str);
	g_free(str);
}

void botcmd_user_set_channel_flags __PARAM__((USER_REC *user, const char *channel, int flags), (user, channel, flags)) __OTORP__(USER_REC *user; const char *channel; int flags;){
	char *str, *flagstr;

        botuser_set_channel_flags(user, channel, flags);

	flagstr = botuser_value2flags(flags);
	str = g_strdup_printf("USER_CHAN_FLAGS %s %s %s", user->nick, channel, flagstr);
	g_free(flagstr);

	botnet_broadcast(NULL, NULL, NULL, str);
	g_free(str);
}

void botcmd_user_add_mask __PARAM__((USER_REC *user, const char *mask), (user, mask)) __OTORP__(USER_REC *user; const char *mask;){
	char *str;

	botuser_add_mask(user, mask);

	str = g_strdup_printf("USER_ADD_MASK %s %s", user->nick, mask);
	botnet_broadcast(NULL, NULL, NULL, str);
	g_free(str);
}

void botcmd_user_set_mask_notflags __PARAM__((USER_REC *user, const char *mask, int not_flags), (user, mask, not_flags)) __OTORP__(USER_REC *user; const char *mask; int not_flags;){
	char *str, *flagstr;

        botuser_set_mask_notflags(user, mask, not_flags);

	flagstr = botuser_value2flags(not_flags);
	str = g_strdup_printf("USER_MASK_NOTFLAGS %s %s %s", user->nick, mask, flagstr);
	g_free(flagstr);

	botnet_broadcast(NULL, NULL, NULL, str);
	g_free(str);
}

void botcmd_user_set_password __PARAM__((USER_REC *user, const char *password), (user, password)) __OTORP__(USER_REC *user; const char *password;){
	char *str;

	botuser_set_password(user, password);

	str = g_strdup_printf("USER_PASS %s %s", user->nick, password);
	botnet_broadcast(NULL, NULL, NULL, str);
	g_free(str);
}

static void botnet_event_user_add __PARAM__((BOT_REC *bot, const char *data, const char *sender), (bot, data, sender)) __OTORP__(BOT_REC *bot; const char *data; const char *sender;){
	char *nick;
	__V_ *free_arg;

	if (!cmd_get_params(data, &free_arg, 1, &nick))
		return;

	botuser_add(nick);
        cmd_params_free(free_arg);
}

static void botnet_event_user_flags __PARAM__((BOT_REC *bot, const char *data, const char *sender), (bot, data, sender)) __OTORP__(BOT_REC *bot; const char *data; const char *sender;){
	USER_REC *user;
	char *nick, *flags;
	__V_ *free_arg;

	if (!cmd_get_params(data, &free_arg, 2, &nick, &flags))
		return;

	user = botuser_find(nick, NULL);
	if (user == NULL) user = botuser_add(nick);
	botuser_set_flags(user, botuser_flags2value(flags));

        cmd_params_free(free_arg);
}

static void botnet_event_user_chan_flags __PARAM__((BOT_REC *bot, const char *data, const char *sender), (bot, data, sender)) __OTORP__(BOT_REC *bot; const char *data; const char *sender;){
	USER_REC *user;
	char *nick, *channel, *flags;
	__V_ *free_arg;

	if (!cmd_get_params(data, &free_arg, 3, &nick, &channel, &flags))
		return;

	user = botuser_find(nick, NULL);
	if (user == NULL) user = botuser_add(nick);
	botuser_set_channel_flags(user, channel, botuser_flags2value(flags));

        cmd_params_free(free_arg);
}

static void botnet_event_user_add_mask __PARAM__((BOT_REC *bot, const char *data, const char *sender), (bot, data, sender)) __OTORP__(BOT_REC *bot; const char *data; const char *sender;){
	USER_REC *user;
	char *nick, *mask;
	__V_ *free_arg;

	if (!cmd_get_params(data, &free_arg, 2, &nick, &mask))
		return;

	user = botuser_find(nick, NULL);
	if (user == NULL) user = botuser_add(nick);
	botuser_add_mask(user, mask);

        cmd_params_free(free_arg);
}

static void botnet_event_user_mask_notflags __PARAM__((BOT_REC *bot, const char *data, const char *sender), (bot, data, sender)) __OTORP__(BOT_REC *bot; const char *data; const char *sender;){
	USER_REC *user;
	char *nick, *mask, *not_flags;
	__V_ *free_arg;

	if (!cmd_get_params(data, &free_arg, 3, &nick, &mask, &not_flags))
		return;

	user = botuser_find(nick, NULL);
	if (user == NULL) user = botuser_add(nick);
	botuser_set_mask_notflags(user, mask, botuser_flags2value(not_flags));

        cmd_params_free(free_arg);
}

static void botnet_event_user_pass __PARAM__((BOT_REC *bot, const char *data, const char *sender), (bot, data, sender)) __OTORP__(BOT_REC *bot; const char *data; const char *sender;){
	USER_REC *user;
	char *nick, *pass;
	__V_ *free_arg;

	if (!cmd_get_params(data, &free_arg, 2, &nick, &pass))
		return;

	user = botuser_find(nick, NULL);
	if (user == NULL) user = botuser_add(nick);
	botuser_set_password(user, pass);

	cmd_params_free(free_arg);
}

void botnet_users_init __PARAM__((void), ()){
	signal_add("botnet event user_add", (SIGNAL_FUNC) botnet_event_user_add);
	signal_add("botnet event user_flags", (SIGNAL_FUNC) botnet_event_user_flags);
	signal_add("botnet event user_chan_flags", (SIGNAL_FUNC) botnet_event_user_chan_flags);
	signal_add("botnet event user_add_mask", (SIGNAL_FUNC) botnet_event_user_add_mask);
	signal_add("botnet event user_mask_notflags", (SIGNAL_FUNC) botnet_event_user_mask_notflags);
	signal_add("botnet event user_pass", (SIGNAL_FUNC) botnet_event_user_pass);
}

void botnet_users_deinit __PARAM__((void), ()){
	signal_remove("botnet event user_add", (SIGNAL_FUNC) botnet_event_user_add);
	signal_remove("botnet event user_flags", (SIGNAL_FUNC) botnet_event_user_flags);
	signal_remove("botnet event user_chan_flags", (SIGNAL_FUNC) botnet_event_user_chan_flags);
	signal_remove("botnet event user_add_mask", (SIGNAL_FUNC) botnet_event_user_add_mask);
	signal_remove("botnet event user_mask_notflags", (SIGNAL_FUNC) botnet_event_user_mask_notflags);
	signal_remove("botnet event user_pass", (SIGNAL_FUNC) botnet_event_user_pass);
}
